package tunnel;

import java.io.IOException;

import javax.servlet.ServletException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class TunnelServlet extends HttpServlet {

    protected void doPost(HttpServletRequest request,
            HttpServletResponse response) throws IOException, ServletException {
        String target = request.getPathInfo();
        if (target == null) {
            response.sendError(HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        if (target.startsWith("/")) target = target.substring(1);
        int index = target.indexOf('/');
        if (index != -1) target = target.substring(0, index);
        TunnelPipe pipe = TunnelPipe.getInstance(target, 139,
                request.getSession().getId());
        try {
            pipe.deliver(request.getContentLength(), request.getInputStream(),
                    response.getOutputStream());
        } catch (IOException ex) {
            System.err.println("delivery error: " + ex);
            ex.printStackTrace();
            throw ex;
        }
    }

}
